# SHIFT6mq

## Custom ROM Setup 
> Allgemeine Übersicht

1. fastboot/adb an den Start bringen
2. Geräteverbindung checken (ggf. Bootloader entsperren)
3. Recovery, Magisk, ROM laden
4. Recovery flashen (z.B. TWRP via fastboot Menü, Tastenkombination)
5. Magisk & ROM installieren (Magisk zum rooten nutzen, ggf. nachträglich)
6. have fun
7. Bonus: root via Magisk

## Reference Links

- https://wiki.lineageos.org/adb_fastboot_guide.html
- https://box4gsm.blogspot.com/2019/11/how-to-install-adb-and-fastboot-on-arch.html
- https://doc.e.foundation/devices/axolotl/install
- https://doc.e.foundation/build-status
- https://magisk.me/
- https://github.com/topjohnwu/Magisk
- https://topjohnwu.github.io/Magisk/install.html


**extra:**
> - https://lineageosroms.com/axolotl/
> - https://skyhawkrecovery.github.io/Devices.html (TWPR Theme + Features)
> - https://twrp.me/




## Steps to take

### 0. Gerät vorbereiten

Zurücksetzen und OHNE Internet Verbindung und Google Account an den Start bringen!

### 1. fastboot & adb an den Start bringen

**Manjaro Cinnamon - Arch Linux Setup**

![Video](https://www.youtube.com/watch?v=CWWf1M25jYs)

`sudo pacman -S android-tools`

**Ubuntu based Systems**

https://www.digitbin.com/install-use-adb-fastboot-linux/

### 2. Geräteverbindung aufbauen

Laut [Anleitung](https://doc.e.foundation/devices/axolotl/install) via Tastenkombination

`Volume Up + Power` 

Startet den `FASTBOOT` Download Modus 

(Screenshot)

Via Terminal überprüfen mit 

`fastboot devices`

(Screenshot)

> Falls Ausfall/zu lange nicht verwendet: Nochmal Tastenkombination bis das Gerät erneut in den Modus startet!

Wenn der Fasstboot Check erfolgreich war, den Bootloader checken mit der Auswahl `Reboot to bootloader` und dort steht dann der lock/unlock status vom bootloader. 

Falls Bootloader zu entsperren ist mit 

`fastboot flashing unlock` 

freigeben. 

> ggf. kommt folgende Fehlermeldung:
>
>```
>FAILED (remote: 'Flashing Unlock is not allowed')
>fastboot: error: Command failed
>```
> in diesem Fall "OEM unlock" via erweiterter Geräteeinstellungen im OS notwendig, wenn keine Ausgabe möglich

Erfolgreich wenn folgende Meldung erfolgt:

```
OKAY [  0.036s]
Finished. Total time: 0.037s

```
> :warning: Das Bootloader entsperren resettet und rebootet das Gerät!

Danach noch die Auswahl "UNLOCK THE BOOTLOADER" bestätigen. 

> :exclamation: im Anschluss ist dadurch ein erneutes Freigeben vom USB-debugging notwendig via Geräte Settings (alle anderen Setup-Einstellungen überspringen, wird ohnehin überschrieben)


> **Note:** der bootloader bleibt entsperrt, soweit das die Dokumentation ausweist! überprüfen?


### 3. Recovery, Magisk, ROM laden
> kann parallel zu den anderen Schritten zuvor geschehen

Aktuell ist von eOS nur [Android T(13)](https://images.ecloud.global/dev/axolotl/) als "Test" Version verfügbar, sollte aber stabil laufen. Bekannte [Issues](https://gitlab.e.foundation/groups/e/-/issues/?label_name%5B%5D=axolotl&label_name%5B%5D=type%3A%3ABug) sind hier verlinkt.

**Software bereithalten**

1. [eOS, recovery](https://doc.e.foundation/devices/axolotl)
2. [Magisk](https://magisk.me/zip/) (apk to zip benennen)
3. Microg (bei eOS inkl.)

### 4. Recovery flashen
Nach dem freigeben vom adb (USB-Debugging) Modus (siehe Hinweis oben) wieder in den fastboot/bootloader Modus wechseln und Verbindung prüfen mit `fastboot devices`. 

> Falls das Telefon noch gebootet ist, einfach via `adb reboot bootloader` die Abkürzung nehmen und ddamit auch die USB Verbindung überprüfen.

Terminal in dem Verzeichnis des Recovery Files öffnen oder dort hin navigieren mit `cd ...`.

Anschließend das Custom Recovery (e.g. eOS oder TWRP) flashen mit: 

`fastboot flash recovery <recoveryfilename>.img`

> Beispiel: `fastboot flash recovery recovery-e-1.20-t-20240221382228-dev-axolotl.img`

> Erfolgreich bei folgender Art von Meldung:
> ```
> Sending 'recovery' (98304 KB)                      OKAY [  2.502s]
> Writing 'recovery'                                 OKAY [  0.516s]
> Finished. Total time: 3.029s
>```

Abschließend in das Recovery Modus booten per auswahl oder mit:

`Volume Down + Power` 

### 5. ROM & Magisk installieren

Nun in der eOS Recovery der [Anleitung](https://doc.e.foundation/devices/axolotl/install) folgen und folgende Schritte vornehmen:
- Factory reset
- Apply Update via ADB

Nun mit `adb sideload <eOS-file>.zip` das eOS image 

> Beispiel: `adb sideload e-1.20-t-20240221382228-dev-axolotl.zip`

:exclamation: Nun erscheint nach der 47% Pause anders als in der Anleitung beschrieben kein `Total xfer: 1.00x` sondern es kommt ein Fenster vom Recovery das die Option gibt weitere Pakete zu installieren! z.B. Magisk, hier also "YES" wählen. 

(Screeenshots)

Es ist also möglich nun auch weitere Apps vorab zu laden. Ähnlich wie hier beschrieben:
> "If getting message Signature verification failed click Yes.
>- You'll see process stuck on 47%. Don't worry. Look at your phone screen. It should have an inscription - "To install additional packages, you need to reboot recovery first. Do you want to reboot to recovery now?". If you plan to install gapps, Magisk, etc.., then click Yes (оtherwise, press "No" and "Reboot system now"). The phone will reboot into recovery.
> - To install gapps, Magisk, etc..., sideload gapps.zip, Magisk.apk the same way you installed crDroid.zip then reboot to system.

Nun kommt man wieder in die Recovery übersicht, erneut "Apply Update" via "ADB sideload" Option auswählen.

Mit dem Befehl `adb sideload ...` kann nun auch die `Magisk.zip` (Version runterladen und in .zip umbenennen) geladen werden.

> Falls nach der fehlenden Signatur gefragt wird, einfach mit "YES" trotzdem fortführen!

Ergebnis: `Install completed with status 0.` (keine Fehler, erfolgreich) bzw. am PC `Total xfer: 0.75x`.


### 6. have fun

Jetzt ein happy **Reboot system now**

### 7. Bonus: root via Magisk

Das wird unter 5. direkt mit erledigt allerdings bedarf es einen Re-Install via App:

- Magisk App via f-droid installieren
- re-install wird empfohlen
- :warning: ggf. "In inactive slot" auswählen! sonst muss ROM und Magisk nochmal neu via adb geflasht werden!?
- tbd - hier stimmt noch was nicht, werde die Doku auf Stand bringen

> temp. fix (slot_a ROM auch geflasht zur Sicherheit, aber noch kein Magisk): auf slot_b wo derzeit das aktive ROM (eOS) liegt auch nochmal Magisk flashen via `adb sideload ...` dann nochmal "Direkte Installation (empfohlen)" in der Magisk App wählen, reboot → gerootet
> Das heißt die Doku zu Schritt 5 nochmal überarbeiten, hier erstmal eine Forum-Anfrage: [SHIFT Forum](https://forum.shiftphones.com/threads/shift6mq-lineageos-21-android-14.5270/post-51774)